package com.ekingwin.bas.cloud.document.service.impl;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Primary;
import org.springframework.stereotype.Service;

import com.ekingwin.bas.cloud.document.DocManagerException;
import com.ekingwin.bas.cloud.document.dao.IDocumentMetaDao;
import com.ekingwin.bas.cloud.document.dao.entity.DocumentMeta;
import com.ekingwin.bas.cloud.document.service.IDocumentMetaService;
import com.ekingwin.bas.cloud.infra.dto.QueryDTO;
import com.ekingwin.bas.cloud.infra.exception.BasException;
import com.ekingwin.bas.cloud.infra.service.BaseService;
import com.ekingwin.bas.cloud.infra.utils.db.PageCriteria;
import com.ekingwin.bas.cloud.infra.utils.web.UserUtils;

import tk.mybatis.mapper.entity.Example;

@Primary
@Service
public class DocumentMetaServiceImpl extends BaseService implements IDocumentMetaService{

	@Autowired
	private IDocumentMetaDao docMetaDao;
	
	public void save(DocumentMeta docFile) {
		docMetaDao.insertSelective(docFile);
	}

	@Override
	public void update(DocumentMeta docFile) {
		 docMetaDao.updateByPrimaryKeySelective(docFile);
//		 docMetaDao.updateByPrimaryKey(docFile);
	}
	
	public PageCriteria<DocumentMeta> query(QueryDTO query) throws BasException {
		try {
			Example example = buildQuery(query, DocumentMeta.class);
			return query(query,  
					() -> docMetaDao.selectByExample(example), 
					DocumentMeta.class);
		} catch (Exception e) {
			log.error(e.getMessage(), e);
			throw new DocManagerException(e);
		}
	}

	public void delete(String id) {
		docMetaDao.deleteByPrimaryKey(id);
	}

	public DocumentMeta get(String id) {
		return docMetaDao.selectByPrimaryKey(id);
	}

	

	@Override
	public void deleteDoc(String dID) {
		docMetaDao.deleteDoc(dID);
	}
	
	public boolean updateStatus(String status,String id){
		return docMetaDao.updateStatus(status,UserUtils.getCurrentUser(), id);
	}

	@Override
	public Integer getCollectedOrNot(String dId, String revId,String userId) throws BasException {
		return docMetaDao.getCollectedOrNot(dId,revId,userId);
	}
	
	public String getCollectionId(String dId, String revId,String userId) throws BasException {
		return docMetaDao.getCollectionId(dId,revId,userId);
	}

}
