package com.ekingwin.bas.cloud.org.dao;

import java.util.List;

import org.apache.ibatis.annotations.Param;

import com.ekingwin.bas.cloud.org.dao.entity.OrganizationEsb;
import com.ekingwin.bas.cloud.org.dto.OrganizationEsbDto;
import com.ekingwin.bas.mapper.BasMapper;

import tk.mybatis.mapper.entity.Example;

public interface IOrganizationEsbDao extends BasMapper<OrganizationEsb> {

	public int getNumBySyscodes(@Param("sysid")String sysid, @Param("pcode")String pcode, @Param("code")String code, @Param("fullname")String fullname, @Param("isdelete")String isdelete, @Param("type")String type,
			@Param("name")String name);

	/**
	 * 根据id删除推送数据
	 * @param id
	 */
	public void deleteOrgById(@Param("id")String id);

	/**
	 * 根据id修改推送数据状态
	 * @param id
	 */
	public void modifyOrgById(@Param("id")String id);

	
	public OrganizationEsbDto getOrganizationById(@Param("id")String id);

	public List<OrganizationEsb> getOrganization(@Param("example")Example example);

	/**
	 * 根据系统编码查询该系统是否有推送组织的权限
	 * @param string
	 * @return
	 */
	public int getSystemCodeAndOrgBySyscode(@Param("syscode")String syscode);
	/**
	 * 根据系统编码查询该系统是否有推送岗位的权限
	 * @param string
	 * @return
	 */
	public int getSystemCodeAndPostBySyscode(@Param("syscode")String syscode);

}
