package com.ekingwin.bas.cloud.org.service;

import java.util.Map;

import com.ekingwin.bas.cloud.attachment.dto.FileObject;
import com.ekingwin.bas.cloud.infra.dto.QueryDTO;
import com.ekingwin.bas.cloud.infra.utils.db.PageCriteria;
import com.ekingwin.bas.cloud.org.OrganizationException;
import com.ekingwin.bas.cloud.org.dto.OrganizationDto;
import com.ekingwin.bas.cloud.user.dto.UserDto;

public interface IOrganizationManager {
	
	public FileObject exportsOrg(QueryDTO query) throws OrganizationException;
	
	public FileObject importsOrg() throws OrganizationException;

	public FileObject exportsOrgUser(QueryDTO query) throws OrganizationException;
	
	public FileObject importsUserToOrg() throws OrganizationException;
	
	public void assignUsersToOrg(Map<String, String> map) throws OrganizationException;
	
	public void removeUsersFromOrg(Map<String, String> map) throws OrganizationException;
	
	public PageCriteria<UserDto> queryUsersInOrg(QueryDTO query) throws OrganizationException;
	
	public void assignMaintainersToOrg(Map<String, String> map) throws OrganizationException;
	
	public void removeMaintainersFromOrg(Map<String, String> map) throws OrganizationException;
	
	public PageCriteria<UserDto> queryMaintainersInOrg(QueryDTO query) throws OrganizationException;
	
	public PageCriteria<OrganizationDto> queryOrgForMaintainer(QueryDTO query) throws OrganizationException;

	PageCriteria<UserDto> queryUsersNotInOrg(QueryDTO query)
			throws OrganizationException;

	
	
	public void assignOrgsToUser(Map<String, String> map)throws OrganizationException;
	/**
	 * 删除兼岗
	 * @param map
	 */
	public void removeOrgsToUser(Map<String, Object> map);
	
	
	public void userPostRelation(String operate,String userid) throws OrganizationException;

}
