package com.ekingwin.bas.cloud.org.service;


import com.ekingwin.bas.cloud.infra.dto.BaseResult;
import com.ekingwin.bas.cloud.infra.dto.QueryDTO;
import com.ekingwin.bas.cloud.infra.exception.BasException;
import com.ekingwin.bas.cloud.infra.service.IBaseEntityService;
import com.ekingwin.bas.cloud.infra.utils.db.PageCriteria;
import com.ekingwin.bas.cloud.org.OrganizationException;
import com.ekingwin.bas.cloud.org.dto.OrganizationDto;
import com.ekingwin.bas.cloud.org.dto.OrganizationTreeDto;

import java.util.List;

public interface IOrganizationTreeService extends IBaseEntityService<OrganizationTreeDto> {
	public BaseResult<List<OrganizationTreeDto>>  getChildTreeById(String id) throws OrganizationException;
	public BaseResult<List<OrganizationTreeDto>>  getDirectChildTreeById(OrganizationDto organizationDto) throws OrganizationException;

	PageCriteria<OrganizationTreeDto> getOrgByUser(QueryDTO query)
			throws OrganizationException;
	public List<OrganizationTreeDto> getChildCompanyById(String id) throws OrganizationException;
	
	public List<OrganizationTreeDto> findFirstTree() throws OrganizationException;
	
	public List<OrganizationTreeDto> getFirstTree() throws OrganizationException;

	/**
	 * 根据组织树id和登录人id来查询组织树的详细信息
	 * @param id
	 * @return
	 * @throws OrganizationException 
	 */
	public OrganizationTreeDto getOrgTreeByidAndLogid(String id) throws OrganizationException;

	public PageCriteria<OrganizationTreeDto> getOrganizationTreeByUserId(QueryDTO orgQuery) throws OrganizationException;

	public BaseResult<List<OrganizationTreeDto>> queryOrgTree(QueryDTO orgQuery) throws OrganizationException;
	
	public void genTreecode() throws OrganizationException;
	public void insertTreeByOrg() throws OrganizationException;
	/**
	 * 获取租户的以及组织信息
	 * @return
	 * @throws BasException
	 */
	public BaseResult<List<OrganizationTreeDto>> getTenantOrganization() throws BasException;
}
