package com.ekingwin.bas.cloud.org.service.impl;

import java.awt.HeadlessException;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.swing.JOptionPane;

import org.apache.commons.lang3.StringUtils;
import org.apache.poi.hssf.usermodel.HSSFCell;
import org.apache.poi.hssf.usermodel.HSSFCellStyle;
import org.apache.poi.hssf.usermodel.HSSFRow;
import org.apache.poi.hssf.usermodel.HSSFSheet;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.Row;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.context.annotation.Primary;
import org.springframework.stereotype.Service;

import com.ekingwin.bas.cloud.attachment.dto.FileObject;
import com.ekingwin.bas.cloud.infra.dto.FilterDTO;
import com.ekingwin.bas.cloud.infra.dto.QueryDTO;
import com.ekingwin.bas.cloud.infra.exception.BasException;
import com.ekingwin.bas.cloud.infra.service.BaseService;
import com.ekingwin.bas.cloud.infra.utils.db.PageCriteria;
import com.ekingwin.bas.cloud.infra.utils.web.UserUtils;
import com.ekingwin.bas.cloud.org.OrganizationException;
import com.ekingwin.bas.cloud.org.dao.IMainInOrgViewDao;
import com.ekingwin.bas.cloud.org.dao.IOrgForMainViewDao;
import com.ekingwin.bas.cloud.org.dao.IOrganizationManagerDao;
import com.ekingwin.bas.cloud.org.dao.IPostUserEsbDao;
import com.ekingwin.bas.cloud.org.dao.IUserInOrgViewDao;
import com.ekingwin.bas.cloud.org.dao.entity.MainInOrgView;
import com.ekingwin.bas.cloud.org.dao.entity.OrgForMainView;
import com.ekingwin.bas.cloud.org.dao.entity.PostUserEsb;
import com.ekingwin.bas.cloud.org.dto.OrganizationAuthorityDto;
import com.ekingwin.bas.cloud.org.dto.OrganizationDto;
import com.ekingwin.bas.cloud.org.dto.OrganizationTreeDto;
import com.ekingwin.bas.cloud.org.dto.PostUserEsbDto;
import com.ekingwin.bas.cloud.org.service.IOrganizationAuthorityService;
import com.ekingwin.bas.cloud.org.service.IOrganizationManager;
import com.ekingwin.bas.cloud.org.service.IOrganizationService;
import com.ekingwin.bas.cloud.user.dao.UserDao;
import com.ekingwin.bas.cloud.user.dao.entity.User;
import com.ekingwin.bas.cloud.user.dto.UserDto;
import com.ekingwin.bas.cloud.user.service.IUserMetaService;

import tk.mybatis.mapper.entity.Example;
@Service
@Primary
public class OrganizationManagerImpl extends BaseService implements IOrganizationManager {
	
	@Autowired
	private IOrganizationManagerDao orgManagerDao;
	
	@Autowired
	private IUserInOrgViewDao userInOrgViewDao;
	
	
	@Autowired
	private IMainInOrgViewDao mainInOrgViewDao;
	
	@Autowired
	private IOrgForMainViewDao orgForMainViewDao;
	
	@Autowired
	private IPostUserEsbDao postUserEsbDao;
	
	
	@Autowired
	@Qualifier(value="organizationAuthorityServiceImpl")
	private IOrganizationAuthorityService orgAutService;
	
	@Autowired
	@Qualifier(value="organizationServiceImpl")
	private IOrganizationService orgService;
	
	@Autowired
	private UserDao userDao;
	
	@Autowired
	@Qualifier(value = "userMetaServiceImpl")
	private IUserMetaService userService;

	@Override
	public FileObject exportsOrg(QueryDTO query) throws OrganizationException {
		if (query == null) {
			query = new QueryDTO();
		}
		query.setPageSize(100000);
		 // 声明一个工作薄
		@SuppressWarnings("resource")
		HSSFWorkbook wb = new HSSFWorkbook();
		// 声明一个单子并命名
		HSSFSheet sheet = wb.createSheet("导出组织");
		// 给单子名称一个长度
		sheet.setDefaultColumnWidth((short) 15);
		// 生成一个样式
		HSSFCellStyle style = wb.createCellStyle();
		// 创建第一行（也可以称为表头）
		HSSFRow row = sheet.createRow(0);
		// 样式字体居中
		//style.setAlignment(HSSFCellStyle.ALIGN_CENTER);
		// 给表头第一行一次创建单元格
		HSSFCell cell = row.createCell((short) 0);
		cell.setCellValue("主键");
		cell.setCellStyle(style);
		cell = row.createCell((short) 1);
		cell.setCellValue("组织名称");
		cell.setCellStyle(style);
		cell = row.createCell((short) 2);
		cell.setCellValue("英文名称");
		cell.setCellStyle(style);
		cell = row.createCell((short) 3);
		cell.setCellValue("编号");
		cell.setCellStyle(style);
		cell = row.createCell((short) 4);
		cell.setCellValue("全名");
		cell.setCellStyle(style);	
		cell = row.createCell((short) 5);
		cell.setCellValue("备用字段");
		cell.setCellStyle(style);
		cell = row.createCell((short) 6);
		cell.setCellValue("");
		cell.setCellStyle(style);
		cell = row.createCell((short) 7);
		cell.setCellValue("");
		cell.setCellStyle(style);
		cell = row.createCell((short) 8);
		cell.setCellValue("类型");
		cell.setCellStyle(style);
		cell = row.createCell((short) 9);
		cell.setCellValue("其他系统id");
		cell.setCellStyle(style);
		cell = row.createCell((short) 10);
		cell.setCellValue("是否删除");
		cell.setCellStyle(style);
		cell = row.createCell((short) 11);
		cell.setCellValue("上级组织编码");
		cell.setCellStyle(style);
		cell = row.createCell((short) 12);
		cell.setCellValue("货币");
		cell.setCellStyle(style);
		cell = row.createCell((short) 13);
		cell.setCellValue("语言");
		cell.setCellStyle(style);
		cell = row.createCell((short) 14);
		cell.setCellValue("增值税登记号");
		cell.setCellStyle(style);
		cell = row.createCell((short) 15);
		cell.setCellValue("地址");
		cell.setCellStyle(style);
		cell = row.createCell((short) 16);
		cell.setCellValue("邮政编码");
		cell.setCellStyle(style);
		cell = row.createCell((short) 17);
		cell.setCellValue("邮政信箱");
		cell.setCellStyle(style);
		cell = row.createCell((short) 18);
		cell.setCellValue("法人代表");
		cell.setCellStyle(style);
		cell = row.createCell((short) 19);
		cell.setCellValue("联系人");
		cell.setCellStyle(style);
		cell = row.createCell((short) 20);
		cell.setCellValue("电话");
		cell.setCellStyle(style);
		cell = row.createCell((short) 21);
		cell.setCellValue("移动电话");
		cell.setCellStyle(style);
		cell = row.createCell((short) 22);
		cell.setCellValue("传真");
		cell.setCellStyle(style);
		cell = row.createCell((short) 23);
		cell.setCellValue("子类型");
		cell.setCellStyle(style);
		cell = row.createCell((short) 24);
		cell.setCellValue("公司所属类型");
		cell.setCellStyle(style);
		cell = row.createCell((short) 25);
		cell.setCellValue("核算区域");
		cell.setCellStyle(style);
		cell = row.createCell((short) 26);
		cell.setCellValue("人事范围");
		cell.setCellStyle(style);
		cell = row.createCell((short) 27);
		cell.setCellValue("人事子范围");
		cell.setCellStyle(style);
		cell = row.createCell((short) 28);
		cell.setCellValue("成本中心");
		cell.setCellStyle(style);
		cell = row.createCell((short) 29);
		cell.setCellValue("业务范围");
		cell.setCellStyle(style);
		cell = row.createCell((short) 30);
		cell.setCellValue("组织单位简称");
		cell.setCellStyle(style);
		
		
		try {
		        List<OrganizationDto> listDto = orgService.query(query).getData().getList();
				// 向单元格里填充数据
				for (short i = 0; i < listDto.size(); i++) {
					row = sheet.createRow(i + 1);
					row.createCell(0).setCellValue(listDto.get(i).getId());
					row.createCell(1).setCellValue(listDto.get(i).getName());
					row.createCell(2).setCellValue(listDto.get(i).getEnname());
					row.createCell(3).setCellValue(listDto.get(i).getCode());
					row.createCell(4).setCellValue(listDto.get(i).getFullname());
					row.createCell(5).setCellValue(listDto.get(i).getType());
					row.createCell(6).setCellValue(listDto.get(i).getOthersystemid());
					row.createCell(7).setCellValue(listDto.get(i).getIsdelete());
					row.createCell(8).setCellValue(listDto.get(i).getAttribute1());
					row.createCell(9).setCellValue(listDto.get(i).getAttribute2());
					row.createCell(10).setCellValue(listDto.get(i).getAttribute3());
					row.createCell(11).setCellValue(listDto.get(i).getPcode());
					row.createCell(12).setCellValue(listDto.get(i).getCurrency());
					row.createCell(13).setCellValue(listDto.get(i).getLanguage());
					row.createCell(14).setCellValue(listDto.get(i).getVatnumber());
					row.createCell(15).setCellValue(listDto.get(i).getAddress());
					row.createCell(16).setCellValue(listDto.get(i).getPostno());
					row.createCell(17).setCellValue(listDto.get(i).getPost_box());
					row.createCell(18).setCellValue(listDto.get(i).getLegalrepresentative());
					row.createCell(19).setCellValue(listDto.get(i).getContact());
					row.createCell(20).setCellValue(listDto.get(i).getPhone());
					row.createCell(21).setCellValue(listDto.get(i).getMobilephone());
					row.createCell(22).setCellValue(listDto.get(i).getFax());
					row.createCell(23).setCellValue(listDto.get(i).getSubtype());
					row.createCell(24).setCellValue(listDto.get(i).getComtype());
					row.createCell(25).setCellValue(listDto.get(i).getAcctarea());
					row.createCell(26).setCellValue(listDto.get(i).getWerks());
					row.createCell(27).setCellValue(listDto.get(i).getSubranges());
					row.createCell(28).setCellValue(listDto.get(i).getCostcenter());
					row.createCell(29).setCellValue(listDto.get(i).getBussscope());
					row.createCell(30).setCellValue(listDto.get(i).getShortname());
					
				}
		} catch (BasException e1) {
			e1.printStackTrace();
		}
		
		 try {
			// 默认导出到E盘下
			FileOutputStream out = new FileOutputStream("E://导出组织.xls");
			wb.write(out);
			out.close();
			JOptionPane.showMessageDialog(null, "导出成功!");
		} catch (FileNotFoundException e) {
			JOptionPane.showMessageDialog(null, "导出成功!");
			e.printStackTrace();
		} catch (IOException e) {
			JOptionPane.showMessageDialog(null, "导出成功!");
			e.printStackTrace();
		}catch(HeadlessException e){
			e.printStackTrace();
		}
		 
		System.setProperty("java.awt.headless","true");
		FileObject fileObject = new FileObject();
		fileObject.setId("2");
		fileObject.setName("导出组织");
		fileObject.setSize(10000000);
		fileObject.setType(".xls");
		return fileObject;
	}

	@Override
	public FileObject importsOrg() throws OrganizationException{
		
		String excelPath = "E://组织.xls";
		try {
			InputStream fis = new FileInputStream(excelPath);
			
			OrganizationDto orgDto = null;
			//创建一个工作簿
			@SuppressWarnings("resource")
			HSSFWorkbook wb = new HSSFWorkbook(fis);
			//得到第一个工作表
			HSSFSheet sheet = wb.getSheetAt(0);
			HSSFRow row = null;
			//获取表头
			Row rowHead = sheet.getRow(0);
			
			//获取总行数
			int rows = sheet.getLastRowNum();
			//日期格式化
			SimpleDateFormat sdf = new SimpleDateFormat("yyy-MM-dd");
			
			
			for(int i=1;i<=rows;i++){
				
				row = sheet.getRow(i);
				orgDto = new OrganizationDto();
			  //获得获得第i行第0列的 String类型对象
	            Cell cell = row.getCell((short)0);
	            String id = String.valueOf((int)cell.getNumericCellValue());
	            
	            
	            cell = row.getCell((short)1);
	            String name = cell.getStringCellValue().toString();
	            
	            
				orgDto.setId(id);
				orgDto.setName(name);
				orgService.save(orgDto);
			}
			
			
			
		/*	
			//遍历该表格中所有的工作表，i表示工作表的数量 getNumberOfSheets表示工作表的总数
			for(int i=0;i<wb.getNumberOfSheets();i++){
				sheet = wb.getSheetAt(i);
				//遍历该行所有的行,j表示行数 getPhysicalNumberOfRows行的总数
				for(int j=0;j<sheet.getPhysicalNumberOfRows();j++){
					//获得第j行对象
					row = sheet.getRow(j+1);
					
					orgDto = new OrganizationDto();
					 
		            //获得获得第i行第0列的 String类型对象
		            Cell cell = row.getCell((short)0);
		            String id = String.valueOf((int)cell.getNumericCellValue());
		            
		            
		            cell = row.getCell((short)1);
		            String name = cell.getStringCellValue();
					orgDto.setId(id);
					orgDto.setName(name);
					orgService.save(orgDto);	
				}
			}
			*/
			
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}catch (HeadlessException e){
			e.printStackTrace();
		}catch (BasException e) {
		    e.printStackTrace();
		}
		System.setProperty("java.awt.headless","true");
		FileObject fileObject = new FileObject();
		fileObject.setId("2");
		fileObject.setName("组织");
		fileObject.setSize(10000000);
		fileObject.setType(".xls");
		return fileObject;
	}

	@Override
	public FileObject exportsOrgUser(QueryDTO query) throws OrganizationException {
		if (query == null) {
			query = new QueryDTO();
		}
		query.setPageSize(100000);
		 // 声明一个工作薄
		@SuppressWarnings("resource")
		HSSFWorkbook wb = new HSSFWorkbook();
		// 声明一个单子并命名
		HSSFSheet sheet = wb.createSheet("导出用户");
		// 给单子名称一个长度
		sheet.setDefaultColumnWidth((short) 15);
		// 生成一个样式
		HSSFCellStyle style = wb.createCellStyle();
		// 创建第一行（也可以称为表头）
		HSSFRow row = sheet.createRow(0);
		// 样式字体居中
		//style.setAlignment(HSSFCellStyle.ALIGN_CENTER);
		// 给表头第一行一次创建单元格
		HSSFCell cell = row.createCell((short) 0);
		cell.setCellValue("登录名");
		cell.setCellStyle(style);
		cell = row.createCell((short) 1);
		cell.setCellValue("工号");
		cell.setCellStyle(style);
		cell = row.createCell((short) 2);
		cell.setCellValue("中文名称");
		cell.setCellStyle(style);
		cell = row.createCell((short) 3);
		cell.setCellValue("英文名称");
		cell.setCellStyle(style);
		cell = row.createCell((short) 4);
		cell.setCellValue("邮件");
		cell.setCellStyle(style);	
		cell = row.createCell((short) 5);
		cell.setCellValue("个人电话");
		cell.setCellStyle(style);
		cell = row.createCell((short) 6);
		cell.setCellValue("所在组");
		cell.setCellStyle(style);
		cell = row.createCell((short) 7);
		cell.setCellValue("");
		cell.setCellStyle(style);
		cell = row.createCell((short) 8);
		cell.setCellValue("逻辑删除标志");
		cell.setCellStyle(style);
		cell = row.createCell((short) 9);
		cell.setCellValue("全名");
		cell.setCellStyle(style);
				
		try {
		        List<UserDto> listDto = queryUsersInOrg(query).getList();
				// 向单元格里填充数据
				for (short i = 0; i < listDto.size(); i++) {
					row = sheet.createRow(i + 1);
					row.createCell(0).setCellValue(listDto.get(i).getEmpuid());
					row.createCell(1).setCellValue(listDto.get(i).getEmpid());
					row.createCell(2).setCellValue(listDto.get(i).getCnname());
					row.createCell(3).setCellValue(listDto.get(i).getEnname());
				
					row.createCell(4).setCellValue(listDto.get(i).getEmail());
					row.createCell(5).setCellValue(listDto.get(i).getPhone());
					row.createCell(6).setCellValue(listDto.get(i).getBirthdate());
					row.createCell(9).setCellValue(listDto.get(i).getDisplayname());
					
					
				}
		} catch (BasException e1) {
			e1.printStackTrace();
		}
		
		 try {
			// 默认导出到E盘下
			FileOutputStream out = new FileOutputStream("E://导出用户.xls");
			wb.write(out);
			out.close();
			JOptionPane.showMessageDialog(null, "导出成功!");
		} catch (FileNotFoundException e) {
			JOptionPane.showMessageDialog(null, "导出成功!");
			e.printStackTrace();
		} catch (IOException e) {
			JOptionPane.showMessageDialog(null, "导出成功!");
			e.printStackTrace();
		}catch (HeadlessException e){
			e.printStackTrace();
		}
		
		System.setProperty("java.awt.headless","true");
		FileObject fileObject = new FileObject();
		fileObject.setId("2");
		fileObject.setName("导出用户");
		fileObject.setSize(10000000);
		fileObject.setType(".xls");
		return fileObject;
	}

	@Override
	public FileObject importsUserToOrg() throws OrganizationException {
		String excelPath = "E://用户.xls";
		try {
			InputStream fis = new FileInputStream(excelPath);
			
			UserDto userDto = null;
			//创建一个工作簿
			@SuppressWarnings("resource")
			HSSFWorkbook wb = new HSSFWorkbook(fis);
			//得到第一个工作表
			HSSFSheet sheet = wb.getSheetAt(0);
			HSSFRow row = null;
			//获取表头
			Row rowHead = sheet.getRow(0);
			Cell orgCell = rowHead.getCell((short)1);
			//获取组织id
			String orgId = String.valueOf((int)orgCell.getNumericCellValue());
			//获取总行数
			int rows = sheet.getLastRowNum();
			//日期格式化
			SimpleDateFormat sdf = new SimpleDateFormat("yyy-MM-dd");
			
			Map<String, String> map = new HashMap<String,String>();
			map.put("orgId", orgId);
			
			for(int i=2;i<=rows;i++){
				
				row = sheet.getRow(i);
				userDto = new UserDto();
			  //获得获得第i行第0列的 String类型对象
	            Cell cell = row.getCell((short)0);
	            String empuid = String.valueOf((int)cell.getNumericCellValue());
	            map.put("userId", empuid);
	            
	            cell = row.getCell((short)1);
	            String empid = String.valueOf((int)cell.getNumericCellValue());
	            
	            cell = row.getCell((short)2);
	            
	            String is_deleted = cell.getStringCellValue().toString();
				userDto.setEmpuid(empuid);
				userDto.setEmpid(empid);
				orgManagerDao.assignUsersToOrg(map);
				
			}
			
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		} catch (HeadlessException e){
			e.printStackTrace();
		}
		
		System.setProperty("java.awt.headless","true");
		FileObject fileObject = new FileObject();
		fileObject.setId("2");
		fileObject.setName("用户");
		fileObject.setSize(10000000);
		fileObject.setType(".xls");
		return fileObject;
		
	}
	
	/**
	 * 将用户添加到组织下
	 */
	@Override
	public void assignUsersToOrg(Map<String, String> map) throws OrganizationException{
		try {
			String userIds = map.get("userIds");
			String orgIds = map.get("orgIds");
			String[] orgIdArry = orgIds.split(",");
			String[] userIdArry = userIds.split(",");
			
			for(String orgid:orgIdArry){
				for(String userid:userIdArry){
					Map<String, String> nmap = new HashMap<String,String>();
					nmap.put("orgId", orgid);
					nmap.put("userId", userid);
					orgManagerDao.assignUsersToOrg(nmap);
				}
			}
		} catch (Exception e) {
			log.error(e.getMessage(), e);
			throw new OrganizationException(e.getMessage(), e);
		}
				
	}
	
   // 将用户移除组织
	@Override
	public void removeUsersFromOrg(Map<String, String> map) throws OrganizationException {
		try {
			String userids = map.get("userIds");
			String orgids = map.get("orgIds");
			if(!StringUtils.isEmpty(userids) && !StringUtils.isEmpty(orgids)){
				String[] userIdArry = userids.split(",");
				String[] orgIdArry = orgids.split(",");
				for(String orgid:orgIdArry){
					for(String userid:userIdArry){
						Map<String, String> nmap = new HashMap<String,String>();
						nmap.put("orgId", orgid);
						nmap.put("userId", userid);
						orgManagerDao.removeUsersFromOrg(nmap);
						//TODO 不知道是不是删除岗位
						userPostRelation("0",userid);
					}
				}
			}
		} catch (Exception e) {
			log.error(e.getMessage(), e);
			throw new OrganizationException(e.getMessage(), e);
		}
			
		
	}
    
	//分配管理员
	@Override
	public void assignMaintainersToOrg(Map<String, String> map) {
		try {
			String userIds = map.get("userIds");
			String orgIds = map.get("orgIds");

			OrganizationAuthorityDto orgAutDto = new OrganizationAuthorityDto(); 
			orgAutDto.setUserid(userIds);
			orgAutDto.setOrgid(orgIds);
			orgAutService.saveAll(orgAutDto);
		} catch (Exception e) {
			try {
				throw new OrganizationException(e.getMessage(), e);
			} catch (OrganizationException e1) {
				log.error(e.getMessage(), e);
				e1.printStackTrace();
			}
		}
			
		
	}

    //移除管理员
	@Override
	public void removeMaintainersFromOrg(Map<String, String> map) {
		try {
			String userIds = map.get("userIds");
			String orgIds = map.get("orgIds");
			String[] userIdArry = userIds.split(",");
			String[] orgIdArry = orgIds.split(",");
			
			for(int i=0;i<userIdArry.length;i++){
				for(int j=0;j<orgIdArry.length;j++){
					Map<String, String> nmap = new HashMap<String, String>();
					nmap.put("userId", userIdArry[i]);
					nmap.put("orgId", orgIdArry[j]);
					
					orgAutService.removeMaintainersFromOrg(nmap);
				}
			}	
		} catch (Exception e) {
			try {
				throw new OrganizationException(e.getMessage(), e);
			} catch (OrganizationException e1) {	
				log.error(e.getMessage(), e);
				e1.printStackTrace();
			}
		}
			
		
	}
	
	//查询指定组织的用户
	@Override
	public PageCriteria<UserDto> queryUsersInOrg(QueryDTO query) throws OrganizationException{
		try {
			String orgid = query.getAttr().get("orgid");
			Example example = buildQuery(query, User.class);
			
			List<OrganizationTreeDto> fList = orgService.selectFirstTree();
			boolean flag = false;
			loop:for(OrganizationTreeDto orgTreeDto:fList){
				List<OrganizationTreeDto> acList = orgService.getAllChildTree(orgTreeDto.getId());
				for(OrganizationTreeDto acorgTreeDto:acList){
					if(orgid.equals(acorgTreeDto.getId())){
						flag = true;
						break loop;
					}
					
				}
		    }
			
			if(flag){
				 return query(query, 
							() -> userDao.getUsersByOrg(example,orgid), 
							UserDto.class);
			}else{
				return userService.getUsersByUser(query);
			}
			
			 
		} catch (Exception e) {
			log.error(e.getMessage(), e);
			throw new OrganizationException(e);
		}
	
	}
	
	@Override
	public PageCriteria<UserDto> queryUsersNotInOrg(QueryDTO query)
			throws OrganizationException {
		try {
			String userid = UserUtils.getCurrentUser();
			String orgid = query.getAttr().get("orgid");
			Example example = buildQuery(query, User.class);
			return query(query, 
						() -> userDao.getUsersByNotOrg(example, orgid,userid), 
						UserDto.class);
		} catch (Exception e) {
			log.error(e.getMessage(), e);
			throw new OrganizationException(e);
		}
	}
    
	//查询组织的管理员
	@Override
	public PageCriteria<UserDto> queryMaintainersInOrg(QueryDTO query) throws OrganizationException {
		try {
			
			Example example = buildQuery(query, MainInOrgView.class);
			return query(query,  
					() -> mainInOrgViewDao.selectByExample(example), 
					UserDto.class);
		} catch (Exception e) {
			log.error(e.getMessage(), e);
			throw new OrganizationException(e);
		}
	}
    
	//查询管理员的组织
	@Override
	public PageCriteria<OrganizationDto> queryOrgForMaintainer(QueryDTO query) throws OrganizationException {
		 
		try {
			FilterDTO filterDto = new FilterDTO();
			List<FilterDTO> filters = new ArrayList<FilterDTO>();
			filterDto.setKey("userId");
			String userId = UserUtils.getCurrentUser();
			filterDto.setValue(userId);
			filters.add(filterDto);
			query.setFilters(filters);
			Example example = buildQuery(query, OrgForMainView.class);
			return query(query,  
					() -> orgForMainViewDao.selectByExample(example), 
					OrganizationDto.class);
		} catch (Exception e) {
			log.error(e.getMessage(), e);
			throw new OrganizationException(e);
		}
	}
   //添加岗位
	@Override
	public void assignOrgsToUser(Map<String, String> map) throws OrganizationException {
		try {
			String userIds = map.get("userIds");
			String orgIds = map.get("orgIds");
			String ismainpost = map.get("ismainpost");
			String[] orgIdArry = orgIds.split(",");
			String[] userIdArry = userIds.split(",");
			for(String orgid:orgIdArry){
				if (!StringUtils.isEmpty(orgid)) {
					for(String userid:userIdArry){
						if (!StringUtils.isEmpty(userid)) {
							Map<String, String> nmap = new HashMap<String,String>();
							nmap.put("orgId", orgid);
							nmap.put("userId", userid);
							nmap.put("ismainpost", ismainpost);
							orgManagerDao.assignOrgsToUser(nmap);
							userPostRelation("1",userid);

						}
					}
				}
			}
			
		} catch (Exception e) {
			log.error(e.getMessage(), e);
			throw new OrganizationException(e.getMessage(), e);
		}
		
		
	}
	
	//员工关联岗位数据推送
	public void userPostRelation(String operate,String userid) throws OrganizationException{
		try {
			//TODO 组织IDM018webservice调用数据
			//1、根据员工id查询系统编码，如果没有系统编码，不调用
			List<String> sysCodes = userDao.getSystemcodeAndPostUserByUserId(userid);
			for (String syscode : sysCodes) {
				//2、根据员工id查询员工信息
				UserDto userDto = userService.get(userid).getData();
				//3、根据员工id获取岗位信息及是否主岗
				List<Map<String, String>> posts = postUserEsbDao.getPostsByUserId(userid);
				for (Map<String, String> maps : posts) {
					String isP = maps.get("ISMAINPOST");
					String postCode = maps.get("CODE");
					String primarypost = "0";
					if (!StringUtils.isEmpty(isP)) {
						if (isP.equals("P")) {
							primarypost = "1";
						}
					}
					int row = postUserEsbDao.getNumByInfos(syscode,userDto.getEmpid(),primarypost,postCode,"1");
					if (row == 0) {
						PostUserEsbDto pueDto = new PostUserEsbDto();
						pueDto.setCode(postCode);
						pueDto.setEmpuid(userDto.getEmpid());
						pueDto.setPrimarypost(primarypost);
						pueDto.setOperate(operate);
						pueDto.setStatus("0");
						pueDto.setPushnum(0);
						pueDto.setSysid(syscode);
						pueDto.setUpdateon(new Date());
						save(pueDto, PostUserEsb.class, postUserEsbDao);
					}
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
			throw new OrganizationException();
		}
	}

	@Override
	public void removeOrgsToUser(Map<String, Object> map) {
		orgManagerDao.removeOrgsToUser(map);
		
	}

	
}
