package com.ekingwin.bas.cloud.org.web;



import com.ekingwin.bas.cloud.infra.dto.BaseResult;
import com.ekingwin.bas.cloud.infra.dto.QueryDTO;
import com.ekingwin.bas.cloud.infra.utils.db.PageCriteria;
import com.ekingwin.bas.cloud.infra.web.BaseController;
import com.ekingwin.bas.cloud.org.dto.OrganizationUserDto;
import com.ekingwin.bas.cloud.org.service.IOrganizationUserService;
import com.ekingwin.bas.cloud.org.vo.OrganizationCompanyVo;
import com.ekingwin.bas.cloud.util.Result;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

@RestController
@RequestMapping("/org/user")
@Api("用户组织和用户的关系")
public class OrganizationUserController extends BaseController{
	@Autowired
	private IOrganizationUserService orgUserSer;
	@RequestMapping(value = "/query", method = RequestMethod.POST)
	@ApiOperation("根据过滤条件用户组织关系信息")
	public BaseResult<PageCriteria<OrganizationUserDto>> query(
			@RequestBody(required = false) QueryDTO query) throws Exception {
		return orgUserSer.query(query);
	}
	
	@RequestMapping(value = "/save", method = RequestMethod.POST)
	@ApiOperation("对组织用户增加与修改")
	public BaseResult<OrganizationUserDto> saveUser(@RequestBody OrganizationUserDto orguser) throws Exception {
		return orgUserSer.save(orguser);
	}

	@RequestMapping(value = "/get/{id}", method = RequestMethod.GET)
	@ApiOperation("根据id获取组织人员中间表信息")
	public BaseResult<OrganizationUserDto> getUser(@PathVariable(value = "id") String id)
			throws Exception {
		BaseResult<OrganizationUserDto> result=orgUserSer.get(id);
		return result;
	}

	@RequestMapping(value = "/delete/{userid}/{orgid}", method = RequestMethod.GET)
	@ApiOperation("删除用户与组织的关系")
	public Result delete(@PathVariable(value="userid") String userid,@PathVariable(value = "orgid") String orgid) throws Exception {
		boolean result = orgUserSer.deleteUser(userid,orgid);
		return Result.ok(result);
	}



	@RequestMapping(value = "/getCompanyByUserId/{userid}", method = RequestMethod.GET)
	@ApiOperation("获取当前登录用户所在公司")
	public Result getCompanyByUserId(@PathVariable(value="userid") String userid) throws Exception {

		List<OrganizationCompanyVo>  companyVoList=orgUserSer.getCompanyByUserId(userid);
		return Result.ok(companyVoList);
	}

	
}
