package com.ekingwin.bas.cloud.rolejcy.web;

import com.ekingwin.bas.cloud.rolejcy.dto.IRoleegoPageDto;
import com.ekingwin.bas.cloud.rolejcy.service.IRoleegoService;
import com.ekingwin.bas.cloud.rolejcy.vo.RoleInfoVo;
import com.ekingwin.bas.cloud.util.Result;
import com.github.pagehelper.PageInfo;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.web.bind.annotation.*;

/**
 * @author Administrator
 * @ClassName RoleegoController
 * @Date 2019/8/1 11:51
 * @Version 1.0
 **/

@RestController
@RequestMapping("/role")
@Api("角色管理")
public class RoleegoController {

    @Autowired
    @Qualifier("roleegoServiceImpl")
    private IRoleegoService iRoleegoService;

    @PostMapping(value = "/authorityRoleUserPage")
    @ApiOperation("已添加角色成员列表")
    public Result authorityRoleUserPage(@RequestBody IRoleegoPageDto iRoleegoPageDto) throws Exception{
        PageInfo<RoleInfoVo> roleInfoVoPageInfo = iRoleegoService.selectRolePage(iRoleegoPageDto);
        return Result.ok(roleInfoVoPageInfo);
    }

    @PostMapping(value = "getAllUserPage")
    @ApiOperation(value = "获取所有人员信息",notes = "获取所有人员信息")
    public Result getAllUserPage(@RequestBody IRoleegoPageDto iRoleegoPageDto) throws Exception{
        PageInfo<RoleInfoVo> roleInfoVoPageInfo = iRoleegoService.selectAllUserPage(iRoleegoPageDto);
        return Result.ok(roleInfoVoPageInfo);
    }
}
