package com.ekingwin.bas.cloud.tenant.service;

import java.util.List;

import com.ekingwin.bas.cloud.infra.exception.BasException;
import com.ekingwin.bas.cloud.infra.service.IBaseCurdService;
import com.ekingwin.bas.cloud.tenant.dto.TenantDto;
import com.ekingwin.bas.cloud.tenant.dto.TenantOrganizationDto;

public interface ITenantService extends IBaseCurdService<TenantDto> {

	/**
	 * 根据社会信用代码查询公司信息
	 * @param creditcode
	 * @return
	 * @throws BasException
	 */
	public TenantDto getByCreditcode(String creditcode) throws BasException;
	/**
	 * 根据租户ID获取租户与组织对应关系
	 * @param tenantid
	 * @return
	 * @throws BasException
	 */
	public List<TenantOrganizationDto> getTenantOrganizationByTenantid(String tenantid) throws BasException;

}
