package com.ekingwin.bas.cloud.thirdinterface.org.web;

import java.io.InputStream;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.servlet.ModelAndView;

import com.ekingwin.bas.cloud.infra.dto.BaseResult;
import com.ekingwin.bas.cloud.infra.dto.QueryDTO;
import com.ekingwin.bas.cloud.infra.dto.SaveResultDTO;
import com.ekingwin.bas.cloud.infra.utils.db.PageCriteria;
import com.ekingwin.bas.cloud.infra.utils.web.UserUtils;
import com.ekingwin.bas.cloud.org.dto.OrganizationDto;
import com.ekingwin.bas.cloud.org.dto.OrganizationUserDto;
import com.ekingwin.bas.cloud.user.UserException;
import com.ekingwin.bas.cloud.user.dto.AccountDispose;
import com.ekingwin.bas.cloud.user.dto.UserDto;
import com.ekingwin.bas.cloud.user.dto.UserPostDto;
import com.ekingwin.bas.cloud.user.dto.ViewUserRoleOrgDTO;
import com.ekingwin.bas.cloud.user.service.IUserMetaService;
import com.ekingwin.bas.cloud.user.service.IUserRoleOrgService;
import com.ekingwin.bas.cloud.util.ExportExcelUtils;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;

/**
 * Created by liuch on 2017-5-22.
 */
@RestController
@RequestMapping("/user/api")
@Api("用户userController相关增删改查的基本方法api")
public class UserApiController {

	@Autowired
	@Qualifier(value = "userMetaServiceImpl")
	private IUserMetaService userService;
	@Autowired
	private IUserRoleOrgService userRoleOrgService;

	@RequestMapping(value = "/deltete/{userId}", method = RequestMethod.DELETE)
	public BaseResult<UserDto> deleteUser(@PathVariable(value = "userId")String userId) throws Exception {
		return userService.delete(userId);
	}

	@RequestMapping(value = "/addAccount", method = RequestMethod.POST)
	@ApiOperation("添加用户")
	public BaseResult<UserDto> addAccount(@RequestBody UserDto user) throws Exception {
		return	userService.save(user);
		
	}
	
	
}
