package com.ekingwin.bas.cloud.thirdinterface.user.web;

import com.ekingwin.bas.cloud.infra.dto.BaseResult;
import com.ekingwin.bas.cloud.thirdinterface.user.dto.*;
import com.ekingwin.bas.cloud.user.dto.UsersDto;
import com.ekingwin.bas.cloud.user.service.IUserMetaService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

/**
 * Created by liuch on 2017-5-22.
 */
@RestController
@RequestMapping("/syncuser")
@Api("用户userController相关增删改查的基本方法api")
public class SyncUserController {

	@Autowired
	@Qualifier(value = "userMetaServiceImpl")
	private IUserMetaService userService;

	@RequestMapping(value = "/addAccount", method = RequestMethod.POST)
	@ApiOperation("新增用户")
	public ResponseUser addAccount(@RequestBody(required = true) AddAccountParamDto userParamDto) throws Exception {
		ResponseUser resposeUser =new ResponseUser();
		try {
			List<UsersDto> userdtolist = userParamDto.getUserparmdto().getUserdtoList();
			
			for(UsersDto userdto:userdtolist) {
//				BaseResult<UserDto> responseuser = userService.get(userdto.getEmpuid().toLowerCase());
//				if(null!=responseuser.getData()) {
//					resposeUser.setErrorcode("E0003003");
//					resposeUser.setErrorinfo("用户已存在");
//					return resposeUser;
//				}
//				if((userdto.getCnname()==null||"".equals(userdto.getCnname()))&&null!=userdto.getDisplayname()) {
//					userdto.setCnname(userdto.getDisplayname());
//				}
//				if((userdto.getPhone()==null||"".equals(userdto.getPhone()))&&userdto.getMobilephone()!=null) {
//					userdto.setPhone(userdto.getMobilephone());
//				}
//				userdto.setIsDeleted("N");
//				userdto.setEmpuid(userdto.getEmpuid().toLowerCase());
				userService.saveUser(userdto);
				break;
			}
			resposeUser.setErrorcode("0");
			resposeUser.setMessage("用户创建成功");
		} catch (Exception e) {
			e.printStackTrace();
			resposeUser.setErrorcode("1");
			resposeUser.setErrorinfo("未知的程序异常(业务系统逻辑错误，请联系业务系统管理员)");
		}		
		return resposeUser;
	}
	
	@RequestMapping(value = "/modifyAccount", method = RequestMethod.POST)
	@ApiOperation("修改用户")
	public ResponseUser modifyAccount(@RequestBody(required = true) ModifyAccountParamDto userParamDto) throws Exception {
		ResponseUser responseUser =new ResponseUser();
		try {
			List<UsersDto> userdtolist = userParamDto.getUserparmdto().getUserdtoList();
			for(UsersDto userdto:userdtolist) {
//				userdto.setIsDeleted("N");
//				if(StringUtils.isEmpty(userdto.getEmpuid())) {
//					responseUser.setErrorcode("E0003004");
//					responseUser.setErrorinfo("必填数据不能为空");
//					return responseUser;
//				}
				
				BaseResult<UsersDto> responseuser = userService.getUser(userdto.getEmpuid().toLowerCase());
				if(null==responseuser.getData()) {
					responseUser.setErrorcode("1");
					responseUser.setErrorinfo("用户在系统中不存在");

					return responseUser;
				}

				userdto.setEmpuid(userdto.getEmpuid().toLowerCase());
				userService.saveUser(userdto);
			}
			responseUser.setErrorcode("0");
			responseUser.setMessage("用户修改成功");
		} catch (Exception e) {
			e.printStackTrace();
			responseUser.setErrorcode("1");
			responseUser.setErrorinfo("未知的程序异常(业务系统逻辑错误，请联系业务系统管理员)");
		}		
		return responseUser;
	}
	
//	@RequestMapping(value = "/deleteAccount", method = RequestMethod.POST)
//	@ApiOperation("删除用户")
//	public ResponseUser deleteAccount(@RequestBody(required = true) DeleteAccountParamDto userDelParamDto) throws Exception {
//		ResponseUser responseUser =new ResponseUser();
//		try {
//			List<LoginDto>  loginDtoList=userDelParamDto.getUserparmdto().getLogindtoList();
//			for(LoginDto loginDto : loginDtoList) {
//				userService.delete(loginDto.getLogin().toLowerCase());
//			}
//
//			responseUser.setErrorcode("0");
//			responseUser.setMessage("删除用户成功");
//		} catch (Exception e) {
//			e.printStackTrace();
//			responseUser.setErrorcode("2");
//			responseUser.setErrorinfo("未知的程序异常(业务系统逻辑错误，请联系业务系统管理员)");
//		}
//		return responseUser;
//	}
	
	@RequestMapping(value = "/disableAccount", method = RequestMethod.POST)
	@ApiOperation("禁用用户")
	public ResponseUser disableAccount(@RequestBody(required = true) DisableAccountParamDto userDelParamDto) throws Exception {
		ResponseUser responseUser =new ResponseUser();
		try {
			List<LoginDto>  loginDtoList=userDelParamDto.getUserparmdto().getLogindtoList();
			for(LoginDto loginDto : loginDtoList) {
				userService.disableAccount(loginDto.getLogin().toLowerCase());
			}
			responseUser.setErrorcode("0");
			responseUser.setMessage("禁用用户成功");
		} catch (Exception e) {
			e.printStackTrace();
			responseUser.setErrorcode("1");
			responseUser.setErrorinfo("未知的程序异常(业务系统逻辑错误，请联系业务系统管理员)");
		}		
		return responseUser;
	}
	
	@RequestMapping(value = "/enableAccount", method = RequestMethod.POST)
	@ApiOperation("启用用户")
	public ResponseUser enableAccount(@RequestBody(required = true) EnableAccountParamDto userDelParamDto) throws Exception {
		ResponseUser responseUser =new ResponseUser();
		try {
			List<LoginDto>  loginDtoList=userDelParamDto.getUserparmdto().getLogindtoList();
			for(LoginDto loginDto : loginDtoList) {
				BaseResult<UsersDto> responseuser = userService.getUser(loginDto.getLogin());
				if(responseuser.getData()!=null){
					userService.enableAccount(loginDto.getLogin().toLowerCase());
					responseUser.setErrorcode("0");
					responseUser.setMessage("启用用户成功");
				}else{
					responseUser.setErrorcode("1");
					responseUser.setMessage("用户不存在");
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
			responseUser.setErrorcode("1");
			responseUser.setErrorinfo("未知的程序异常(业务系统逻辑错误，请联系业务系统管理员)");
		}		
		return responseUser;
	}

}
